• Русский
  • ModuleConfig [moduleconfigs.cluster.alauda.io/v1alpha1]

    Description
    ModuleConfig is the Schema for the moduleconfigs API
    Type
    object

    Specification

    PropertyTypeDescription
    apiVersionstring

    APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

    kindstring

    Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

    metadataObjectMeta

    ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

    specobject

    ModuleConfigSpec defines the desired state of ModuleConfig

    statusobject

    ModuleConfigStatus defines the observed state of ModuleConfig

    .spec

    Description
    ModuleConfigSpec defines the desired state of ModuleConfig
    Type
    object
    Required
    deleteabledescriptionlogoname
    PropertyTypeDescription
    affinityobject

    Affinity is the affinity of the plugin.

    appReleasesarray

    AppReleases is the app releases of the module.

    cfgFilenamestring

    CfgFilename is the plugin config filename in chart.

    configobject

    Config is the config of the module.

    crossClusterDependenciesarray

    CrossClusterDependencies indicates the cross-cluster dependencies of this module. Deprecated

    deleteBlockDescriptionstring

    DeleteBlockDescription is the delete block description of the module.

    deleteBlockDescriptionEnstring

    DeleteBlockDescriptionEn is the delete block description of the module in English.

    deleteRiskDescriptionstring

    DeleteRiskDescription is the delete risk description of the module.

    deleteRiskDescriptionEnstring

    DeleteRiskDescriptionEn is the delete risk description of the module in English.

    deleteableboolean

    Deleteable indicates whether the module can be deleted.

    dependenciesarray

    Dependencies is the dependencies of the module.

    deployDescriptorsarray

    DeployDescriptors is the descriptors of the module for deployment.

    descriptionobject

    Description is the description of the module.

    editDescriptorsarray

    EditDescriptors is the descriptors of the module for edit.

    entrypointTemplatestring

    EntrypointTemplate is the entrypoint template of the module.

    labelClusterstring

    LabelCluster is the flag of whether label cluster resource.

    logostring

    Logo is the logo of the module.

    mainChartstring

    MainChart is the main chart of the module.

    mustUpgradeboolean

    MustUpgrade is the flag of whether the module must upgrade.

    namestring

    Name is the name of the module.

    pluginDependenciesobject

    PluginDependencies define the plugins dependent relationship

    resourcesBlockRemovearray

    ResourcesBlockRemove stands for the resources reference with can block remove this plugin, all of theses resources must be deleted before you can remove this plugin.

    skipPlatformConfigboolean

    SkipPlatformConfig stands for skip reference the platform values when renderering the values for AppRelease.

    supportedUpgradeVersionsstring

    SupportedUpgradeVersions is the supported old versions of the module for upgrade.

    targetClusterVersionsarray

    TargetClusterVersions is the target clusters of the module.

    transitTimeoutinteger

    TransitTimeout is the timeout duration for upgrade.

    uiContextobject

    UIContext is the additional attributes for module config.

    upgradeBeforearray

    UpgradeBefore stands for need upgrade before these mouldes

    upgradeDescriptorsarray

    UpgradeDescriptors is the descriptors of the module for upgrade.

    upgradeRiskDescriptionstring

    UpgradeRiskDescription is the upgrade risk description of the module.

    upgradeRiskDescriptionEnstring

    UpgradeRiskDescriptionEn is the upgrade risk description of the module in English.

    upgradeRiskLevelstring

    UpgradeRiskLevel is the upgrade risk level of the module.

    valuesTemplatesobject

    ValuesTemplates is the values templates of the module.

    versionstring

    Version is the version of the module.

    .spec.affinity

    Description
    Affinity is the affinity of the plugin.
    Type
    object
    PropertyTypeDescription
    clusterAffinityobject

    ClusterAffinity defines the cluster affinity

    clusterAntiAffinityobject

    ClusterAntiAffinity defines the cluster anti-affinity

    pluginAntiAffinityarray

    PluginAntiAffinity defines the plugin anti-affinity

    .spec.affinity.clusterAffinity

    Description
    ClusterAffinity defines the cluster affinity
    Type
    object
    PropertyTypeDescription
    matchExpressionsarray

    MatchExpressions is the list of match expressions

    matchLabelsobject

    MatchLabels is the cluster selector

    .spec.affinity.clusterAffinity.matchExpressions

    Description
    MatchExpressions is the list of match expressions
    Type
    array

    .spec.affinity.clusterAffinity.matchExpressions[]

    Description
    A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
    Type
    object
    Required
    keyoperator
    PropertyTypeDescription
    keystring

    The label key that the selector applies to.

    operatorstring

    Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

    valuesarray

    An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.

    .spec.affinity.clusterAffinity.matchExpressions[].values

    Description
    An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
    Type
    array

    .spec.affinity.clusterAffinity.matchExpressions[].values[]

    Type
    string

    .spec.affinity.clusterAffinity.matchLabels

    Description
    MatchLabels is the cluster selector
    Type
    object

    .spec.affinity.clusterAntiAffinity

    Description
    ClusterAntiAffinity defines the cluster anti-affinity
    Type
    object
    PropertyTypeDescription
    matchExpressionsarray

    MatchExpressions is the list of match expressions

    matchLabelsobject

    MatchLabels is the cluster selector

    .spec.affinity.clusterAntiAffinity.matchExpressions

    Description
    MatchExpressions is the list of match expressions
    Type
    array

    .spec.affinity.clusterAntiAffinity.matchExpressions[]

    Description
    A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
    Type
    object
    Required
    keyoperator
    PropertyTypeDescription
    keystring

    The label key that the selector applies to.

    operatorstring

    Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

    valuesarray

    An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.

    .spec.affinity.clusterAntiAffinity.matchExpressions[].values

    Description
    An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.
    Type
    array

    .spec.affinity.clusterAntiAffinity.matchExpressions[].values[]

    Type
    string

    .spec.affinity.clusterAntiAffinity.matchLabels

    Description
    MatchLabels is the cluster selector
    Type
    object

    .spec.affinity.pluginAntiAffinity

    Description
    PluginAntiAffinity defines the plugin anti-affinity
    Type
    array

    .spec.affinity.pluginAntiAffinity[]

    Type
    string

    .spec.appReleases

    Description
    AppReleases is the app releases of the module.
    Type
    array

    .spec.appReleases[]

    Description
    AppRelease is the release of an application
    Type
    object
    Required
    chartVersionsname
    PropertyTypeDescription
    chartVersionsarray

    ChartVersions stands for the app's chart versions

    installConditionstring

    InstallCondition is the condition of installing

    namestring

    Name stands for the release name

    namespacestring

    Namespace stands for the release namespace

    .spec.appReleases[].chartVersions

    Description
    ChartVersions stands for the app's chart versions
    Type
    array

    .spec.appReleases[].chartVersions[]

    Description
    ChartVersion is the version of the chart
    Type
    object
    Required
    namereleaseNameversion
    PropertyTypeDescription
    namestring

    Name stands for the chart's name

    releaseNamestring

    ReleaseName stands for the release name

    versionstring

    Version stands for the chart's version

    .spec.config

    Description
    Config is the config of the module.
    Type
    object

    .spec.crossClusterDependencies

    Description
    CrossClusterDependencies indicates the cross-cluster dependencies of this module. Deprecated
    Type
    array

    .spec.crossClusterDependencies[]

    Type
    string

    .spec.dependencies

    Description
    Dependencies is the dependencies of the module.
    Type
    array

    .spec.dependencies[]

    Description
    ModuleDependency defines the module dependency
    Type
    object
    Required
    moduleName
    PropertyTypeDescription
    instanceNamestring

    InstanceName stands for the dependent module's ModuleInfo CR's name

    moduleNamestring

    ModuleName stands for the dependent module's name

    versionsMatcharray

    VersionMatch stands for the version requirements for the dependent module, any match will be acceptable.

    .spec.dependencies[].versionsMatch

    Description
    VersionMatch stands for the version requirements for the dependent module, any match will be acceptable.
    Type
    array

    .spec.dependencies[].versionsMatch[]

    Type
    string

    .spec.deployDescriptors

    Description
    DeployDescriptors is the descriptors of the module for deployment.
    Type
    array

    .spec.deployDescriptors[]

    Description
    Descriptors defines OLM descriptors http://confluence.alauda.cn/display/cp/OLM+Descriptor
    Type
    object
    Required
    pathx-descriptors
    PropertyTypeDescription
    descriptionstring

    Description is the description of the descriptor

    displayNamestring

    DisplayName is the display name of the descriptor

    pathstring

    Path is the path of the descriptor

    x-descriptorsarray

    X-Descriptors is the list of descriptors

    .spec.deployDescriptors[].x-descriptors

    Description
    X-Descriptors is the list of descriptors
    Type
    array

    .spec.deployDescriptors[].x-descriptors[]

    Type
    string

    .spec.description

    Description
    Description is the description of the module.
    Type
    object
    PropertyTypeDescription
    enstring

    En is the English description

    zhstring

    Zh is the Chinese description

    .spec.editDescriptors

    Description
    EditDescriptors is the descriptors of the module for edit.
    Type
    array

    .spec.editDescriptors[]

    Description
    Descriptors defines OLM descriptors http://confluence.alauda.cn/display/cp/OLM+Descriptor
    Type
    object
    Required
    pathx-descriptors
    PropertyTypeDescription
    descriptionstring

    Description is the description of the descriptor

    displayNamestring

    DisplayName is the display name of the descriptor

    pathstring

    Path is the path of the descriptor

    x-descriptorsarray

    X-Descriptors is the list of descriptors

    .spec.editDescriptors[].x-descriptors

    Description
    X-Descriptors is the list of descriptors
    Type
    array

    .spec.editDescriptors[].x-descriptors[]

    Type
    string

    .spec.pluginDependencies

    Description
    PluginDependencies define the plugins dependent relationship
    Type
    object
    PropertyTypeDescription
    crossClusterobject

    .spec.pluginDependencies.crossCluster

    Type
    object
    PropertyTypeDescription
    oneOfarray

    .spec.pluginDependencies.crossCluster.oneOf

    Type
    array

    .spec.pluginDependencies.crossCluster.oneOf[]

    Type
    object
    Required
    clusterNamepluginName
    PropertyTypeDescription
    clusterNamestring
    pluginNamestring

    .spec.resourcesBlockRemove

    Description
    ResourcesBlockRemove stands for the resources reference with can block remove this plugin, all of theses resources must be deleted before you can remove this plugin.
    Type
    array

    .spec.resourcesBlockRemove[]

    Description
    ResourceReference defines the resource reference
    Type
    object
    PropertyTypeDescription
    apiVersionstring

    API version of the referent.

    kindstring

    Kind of the referent.

    namestring

    Name of the referent.

    namespacestring

    Namespace of the referent.

    .spec.targetClusterVersions

    Description
    TargetClusterVersions is the target clusters of the module.
    Type
    array

    .spec.targetClusterVersions[]

    Type
    string

    .spec.uiContext

    Description
    UIContext is the additional attributes for module config.
    Type
    object
    PropertyTypeDescription
    sizeSettingsobject

    SizeSettings defines a list of size config

    .spec.uiContext.sizeSettings

    Description
    SizeSettings defines a list of size config
    Type
    object
    PropertyTypeDescription
    defaultstring

    Default is name for default size

    quotaTipobject

    QuotaTip is quota tip

    sizesarray

    Sizes defines a list of size config

    .spec.uiContext.sizeSettings.quotaTip

    Description
    QuotaTip is quota tip
    Type
    object
    PropertyTypeDescription
    enstring

    En is the English text

    zhstring

    Zh is the Chinese text

    .spec.uiContext.sizeSettings.sizes

    Description
    Sizes defines a list of size config
    Type
    array

    .spec.uiContext.sizeSettings.sizes[]

    Description
    SizeConfig defines a list of components config
    Type
    object
    Required
    componentsdescriptionnamesize
    PropertyTypeDescription
    componentsobject

    Components defines a list of component config

    descriptionobject

    Description defines description for this size config

    nameobject

    Name defines name for this size config

    sizestring

    Size is name for this config

    .spec.uiContext.sizeSettings.sizes[].components

    Description
    Components defines a list of component config
    Type
    object

    .spec.uiContext.sizeSettings.sizes[].description

    Description
    Description defines description for this size config
    Type
    object
    PropertyTypeDescription
    enstring

    En is the English text

    zhstring

    Zh is the Chinese text

    .spec.uiContext.sizeSettings.sizes[].name

    Description
    Name defines name for this size config
    Type
    object
    PropertyTypeDescription
    enstring

    En is the English text

    zhstring

    Zh is the Chinese text

    .spec.upgradeBefore

    Description
    UpgradeBefore stands for need upgrade before these mouldes
    Type
    array

    .spec.upgradeBefore[]

    Description
    ModuleRef defines the reference for the module
    Type
    object
    Required
    moduleName
    PropertyTypeDescription
    moduleNamestring

    ModuleName stands for the dependent module's name

    .spec.upgradeDescriptors

    Description
    UpgradeDescriptors is the descriptors of the module for upgrade.
    Type
    array

    .spec.upgradeDescriptors[]

    Description
    Descriptors defines OLM descriptors http://confluence.alauda.cn/display/cp/OLM+Descriptor
    Type
    object
    Required
    pathx-descriptors
    PropertyTypeDescription
    descriptionstring

    Description is the description of the descriptor

    displayNamestring

    DisplayName is the display name of the descriptor

    pathstring

    Path is the path of the descriptor

    x-descriptorsarray

    X-Descriptors is the list of descriptors

    .spec.upgradeDescriptors[].x-descriptors

    Description
    X-Descriptors is the list of descriptors
    Type
    array

    .spec.upgradeDescriptors[].x-descriptors[]

    Type
    string

    .spec.valuesTemplates

    Description
    ValuesTemplates is the values templates of the module.
    Type
    object

    .status

    Description
    ModuleConfigStatus defines the observed state of ModuleConfig
    Type
    object
    PropertyTypeDescription
    readyForDeployboolean

    ReadyForDeploy indicates whether the module is ready for deployment.

    targetClusterVersionsarray

    TargetClusterVersions is the target clusters of the module.

    .status.targetClusterVersions

    Description
    TargetClusterVersions is the target clusters of the module.
    Type
    array

    .status.targetClusterVersions[]

    Type
    string

    API Endpoints

    The following API endpoints are available:

    • /apis/cluster.alauda.io/v1alpha1/moduleconfigs
      • DELETE: delete collection of ModuleConfig
      • GET: list objects of kind ModuleConfig
      • POST: create a new ModuleConfig
    • /apis/cluster.alauda.io/v1alpha1/moduleconfigs/{name}
      • DELETE: delete the specified ModuleConfig
      • GET: read the specified ModuleConfig
      • PATCH: partially update the specified ModuleConfig
      • PUT: replace the specified ModuleConfig
    • /apis/cluster.alauda.io/v1alpha1/moduleconfigs/{name}/status
      • GET: read status of the specified ModuleConfig
      • PATCH: partially update status of the specified ModuleConfig
      • PUT: replace status of the specified ModuleConfig

    /apis/cluster.alauda.io/v1alpha1/moduleconfigs

    HTTP method
    DELETE
    Description
    delete collection of ModuleConfig
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    list objects of kind ModuleConfig
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfigList schema
    401 - UnauthorizedEmpty
    HTTP method
    POST
    Description
    create a new ModuleConfig
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyModuleConfig schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfig schema
    201 - CreatedModuleConfig schema
    202 - AcceptedModuleConfig schema
    401 - UnauthorizedEmpty

    /apis/cluster.alauda.io/v1alpha1/moduleconfigs/{name}

    HTTP method
    DELETE
    Description
    delete the specified ModuleConfig
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    HTTP responses
    HTTP codeResponse body
    200 - OKStatus schema
    202 - AcceptedStatus schema
    401 - UnauthorizedEmpty
    HTTP method
    GET
    Description
    read the specified ModuleConfig
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfig schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update the specified ModuleConfig
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfig schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace the specified ModuleConfig
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyModuleConfig schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfig schema
    201 - CreatedModuleConfig schema
    401 - UnauthorizedEmpty

    /apis/cluster.alauda.io/v1alpha1/moduleconfigs/{name}/status

    HTTP method
    GET
    Description
    read status of the specified ModuleConfig
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfig schema
    401 - UnauthorizedEmpty
    HTTP method
    PATCH
    Description
    partially update status of the specified ModuleConfig
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfig schema
    401 - UnauthorizedEmpty
    HTTP method
    PUT
    Description
    replace status of the specified ModuleConfig
    Query parameters
    ParameterTypeDescription
    dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
    fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
    Body parameters
    ParameterTypeDescription
    bodyModuleConfig schemaapplication/json formatted
    HTTP responses
    HTTP codeResponse body
    200 - OKModuleConfig schema
    201 - CreatedModuleConfig schema
    401 - UnauthorizedEmpty